#include <cstdio>

extern int keymap_get_key(int value, int press);

int main(int argc, char **argv)
{
	int ret = 0;
	int i;

	const int input[][2] =
	{
		{54, 1},  /* shift */ /* !!!42!!! */
		{23, 1},  /* i */
		{30, 1},  /* a */
		{54, 0},  /* shift (released) */
		{100, 1}, /* alt-right */
		{16, 1},  /* q */
		{100, 0}, /* alt-right (released) */
		{1, 1},   /* escape */
		{0, 1},   /* accent */
		{225, 1}, /* a */
		{0, 1},   /* accent */
		{0, 1},   /* accent */
		{100, 1}, /* alt-right */
		{27, 1},  /* + */
		{27, 1},  /* + */
		{100, 0}, /* alt-right (released) */
		{54, 1},  /* shift */
		{0, 1},   /* accent */
		{54, 0},  /* shift (released) */
		{225, 1}, /* a */
		{-1, -1}
		
	};
	const int output[] =
	{
		0,   /* (modifier key:shift) */
		73,  /* I */
		65,  /* A */
		0,   /* (modifier key:shift/released) */
		0,   /* (modifier key:alt-right) */
		64,  /* @ */
		0,   /* (modifier key:alt-right/released) */
		-1,  /* (control key) */
		0,   /* (modifier key:accent) */
		-1,  /* á */
		0,   /* (modifier key:accent) */
		39,  /* ' */
		0,   /* (modifier key:alt-right) */
		0,   /* (modifier key:tilde) */
		126, /* ~ */
		0,   /* (modifier key:alt-right/released) */
		0,   /* (modifier key:shift) */
		0,   /* (modifier key:accent backwards) */
		0,   /* (modifier key:shift/released) */
		133, /* `a */
		0
	};

	for(i = 0; input[i][0] != -1; i++)
	{
		int mapval = keymap_get_key(input[i][0], input[i][1]);
		char out[5], map[5];
		sprintf(out, "[--]");
		sprintf(map, "[--]");
		if(output[i] >= 0)
			for(int j = 0; j < 4; j++)
			{
				char tmp = (output[i] >> (3 - j) * 8) & 0xFF;
				out[j] = (tmp ? tmp : 32);
			}
		if(mapval >= 0)
			for(int j = 0; j < 4; j++)
			{
				char tmp = (mapval >> (3 - j) * 8) & 0xFF;
				map[j] = (tmp ? tmp : 32);
			}
		printf("%3i(%i) -> %3i:%s (%3i:%s)\n",
			input[i][0], input[i][1],
			mapval, map,
			output[i], out);
		if(mapval != output[i]) ret++;
	}

	if(ret) fprintf(stderr, "TEST FAILED %i TIMES (out of %i)!\n", ret, i);

	return ret;
}

